2008-12-21  Veerapuram Varadhan  <vvaradhan@novell.com>

	* SqlXml.cs (CreateReader): Better use
	ConformanceLevel.Fragment while creating the reader as column
	values are not really Xml documents.  Also, throw
	SqlNullValueException when data is null.
	(.ctor): Take good care of empty XmlReaders.
	
2008-09-24  Veerapuram Varadhan  <vvaradhan@novell.com>

	* SqlXml.cs (.ctor): Use unicode encoding instead of ASCII.
	
2008-09-24  Veerapuram Varadhan  <vvaradhan@novell.com>

	* SqlXml.cs (.ctor): Handle 0 length streams.
	(get_Value): Throw SqlNullValueException if data is
	null.
	
2008-09-23  Veerapuram Varadhan  <vvaradhan@novell.com>

	* SqlXml.cs (.ctor, get_Value, CreateReader): Implemented and
	removed MonoTODO and MethodNotImplementedException.
	
2008-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDateTime.cs, SqlDecimal.cs, SqlInt32.cs, SqlInt16.cs,
	  SqlByte.cs, SqlInt64.cs, SqlString.cs, SqlDouble.cs,
	  SqlSingle.cs, SqlBinary.cs, SqlMoney.cs, SqlGuid.cs:
	  ok, everything needs the same fix.
	  (Do not let me write exhausting tests for everything.)

2008-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlBoolean.cs : SqlBoolean.Null.Equals(non-null) caused crash.

2008-04-21  Gert Driesen  <drieseng@users.sourceforge.net>

	* SqlDateTime.cs: Changed argument names to match MS. Code formatting.
	* SqlDecimal.cs: Changed argument names to match MS. Code formatting.
	* SqlNotFilledException.cs: Changed argument names to match MS. Code
	formatting.
	* SqlChars.cs: Changed argument names to match MS. Code formatting.
	* SqlTypeException.cs: Changed argument names to match MS. Code
	formatting.
	* SqlXml.cs: Changed argument names to match MS. Code formatting.
	* SqlInt16.cs: Changed argument names to match MS. Code formatting.
	* SqlInt64.cs: Changed argument names to match MS. Code formatting.
	* SqlTruncateException.cs: Changed argument names to match MS.
	Code formatting.
	* SqlDouble.cs: Changed argument names to match MS. Code formatting.
	* SqlSingle.cs: Changed argument names to match MS. Code formatting.
	* SqlBytes.cs: Changed argument names to match MS. Code formatting.
	* SqlNullValueException.cs: Changed argument names to match MS. Code
	formatting.
	* SqlMoney.cs: Changed argument names to match MS. Code formatting.

2007-10-02  Veerapuram Varadhan <vvaradhan@novell.com> 

	* SqlChars.cs, SqlBytes.cs (Read, Write): Implemented missing 2.0 APIs.

2007-09-27  Veerapuram Varadhan <vvaradhan@novell.com> 

	* SqlDecimal.cs, SqlInt32.cs, SqlChars.cs, SqlInt16.cs, SqlInt64.cs,
	  SqlString.cs, SqlDouble.cs (GetXsdType, GetSchema): Removed the
	  extra XmlRootAttribute and GetXsdType will return appropriate
	  modified root attribute for the XML Serializer.  Implemented
	  missing 2.0 API.

2007-09-25  Veerapuram Varadhan  <vvaradhan@novell.com>

	* SqlChars.cs (ReadXml, WriteXml): Implemented APIs.

	* SqlInt16.cs (ReadXml, WriteXml): Implemented APIs.

	* SqlInt32.cs (ReadXml, WriteXml): Implemented APIs.

	* SqlInt64.cs (ReadXml, WriteXml): Implemented APIs.

	* SqlDecimal.cs (ReadXml, WriteXml): Implemented APIs.

	* SqlDouble.cs (ReadXml, WriteXml): Implemented APIs.

	* SqlString.cs (ReadXml, WriteXml): Implemented APIs.

2007-09-25  Nagappan A  <anagappan@novell.com>

	* SqlMoney.cs (implicit, explicit): Implemented missing APIs.

	* SqlBytes.cs (implicit, explicit): Implemented missing APIs.

	* SqlBinary.cs: 2.0 attribute fixes.

	* SqlAlreadyFilledException.cs: 2.0 attribute fixes.

	* SqlBoolean.cs: 2.0 attribute fixes.

	* SqlByte.cs: 2.0 attribute fixes.

	* SqlXml.cs: 2.0 attribute fixes.

	* SqlChars.cs (implicit, explicit): Implemented missing APIs.

	* SqlDecimal.cs (implicit, explicit): Implemented missing APIs.

2007-07-26  Nagappan A  <anagappan@novell.com>

	* SqlString.cs: notNull private member is now updated properly in
	the constructure, based on the argument being passed.

2007-07-24  Nagappan A  <anagappan@novell.com>

	* SqlString.cs: Fixed compilation warning.

	* SqlBytes.cs: Fixed compilation warning.

	* SqlChars.cs: Fixed compilation warning.

2007-05-10  Adar Wesley <adarw@mainsoft.com>

	* SqlBoolean.cs: fixed typo in method names GreaterThanOrEquals,
	LessThanOrEquals.

	* SqlByte.cs: added missing method Modulus.

	* SqlBytes.cs: added missing methods Read, Write.

	* SqlChars.cs: added missing methods ToSqlString, Write.

	* SqlDateTime.cs: added missing methods Add, Subtract.

	* SqlXml.cs: added missing method CreateReader.

2007-05-04  Raja R Harinath  <rharinath@novell.com>

	* SqlDateTime.cs: Rewrite parts converting SQL ticks to and from
	DateTime ticks.  Attempt to understand what the damned 'bilisecond'
	means.

2007-03-09  Nagappan A  <anagappan@novell.com>

	* SqlBoolean.cs (GreaterThan, GreaterThanOrEqual, LessThan)
	(LessThanOrEqual, GetXsdType, operator >, >=, <, <=): Implemented
	missing 2.0 methods.

	* SqlDouble.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlString.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlBinary.cs (Add, GetXsdType): Implemented missing 2.0 methods.

	* SqlByte.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlBytes.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlChars.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlXml.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlGuid.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlInt64.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlInt32.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlInt16.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlNotFilledException.cs: Fixed syntax errors based on class
	status page.

	* SqlDecimal.cs (GetXsdType): Implemented missing method.

	* SqlDateTime.cs (GetXsdType): Implemented missing method.

	* SqlMoney.cs (GetXsdType): Implemented missing 2.0 method.

	* SqlSingle.cs (GetXsdType): Implemented missing 2.0 method.

2007-02-11  Konstantin Triger <kostat@mainsoft.com>

	* SqlDateTime.cs, SqlDecimal.cs, SqlByte.cs, SqlDouble.cs, SqlBoolean.cs,
		SqlBinary.cs, SqlGuid.cs: Added a 2.0 CompareTo override (refactoring).

2007-02-11  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDateTime.cs: changed MaxValue and MinValue initialization, it was
	failing on .net VM.

2007-02-09  Nagappan A  <anagappan@novell.com>

	* SqlNotFilledException.cs: Removed APIs that are not part of both
	1.0 and 2.0.

	* SqlTypeException.cs: Implemented missing attributes.

	* SqlChars.cs, SqlBytes.cs: Implemented missing attributes,
	methods and added IXmlSerializable.

	* SqlDouble.cs, SqlSingle.cs, SqlBinary.cs, SqlString.cs:
	Implemented missing attributes, added IXmlSerializable.

	* SqlXml.cs, SqlInt16.cs, SqlInt32.cs, SqlInt64.cs: Implemented
	missing attributes, added IXmlSerializable.

	* SqlDateTime.cs, SqlDecimal.cs, SqlMoney.cs, SqlGuid.cs:
	Implemented missing attributes, added IXmlSerializable

2006-07-19  Senganal T  <tsenganal@novell.com>

	* SqlDecimal.cs :
		- Ctr : Throw OverflowException is value oveflows
		- AdjustScale : Support values greater than Decimal.MaxValue.
		Throw SqlTruncateException if scale cannot be adjusted.
		- ConvertToPrecScale : Fix the precision
		- Sign : use IsPositive to check for sign
		- ToString : Do not append extrs '0'
		- operator + , -, * : Support values greater than
		decimal.maxvalue. Fix for infinite loop when '-' is
		invoked for some cases.
		- operators >,<,>=.<=,==,!= : Fix operations on negative numbers
	Thanks to Harish Kumar Singh for the patch
	
2006-02-17  Chris Toshok  <toshok@ximian.com>

	* StorageState.cs: correct namespace, and remove "Delayed"
	element.

2006-02-03  Senganal T <tseganal@novell.com>

	* SqlString.cs : 
		- GetUnicodeBytes()
		- GetNonUnicodeBytes() 
		- Constructor 
			Use Encoding class to convert between byte[] and string

2006-01-27  Senganal T <tsenganal@novell.com>

	* SqlDateTime : Corrected the MaxValue for SqlDateTime
	
2005-09-15  Raja R Harinath  <rharinath@novell.com>

	* SqlString.cs (MoneyFormat): Move to SqlMoney.cs.
	(operator SqlString) [SqlMoney variant]: Delegate to
	SqlMoney.ToString ().
	* SqlMoney.cs (MoneyFormat): Move from SqlString.cs.
	(SqlString): New static constructor.
	(ToString): Use it.

2005-09-02 Umadevi S <sumadevi@novell.com>

	* SqlXml.cs : Added a dummy placeholder to compile MicrosoftServer namespace

2005-03-11  Sureshkumar T  <tsureshkumar@novell.com>

	* SqlDateTime.cs (Parse): Re-org. Resolve unreachable code.

2005-02-11  Sureshkumar T  <tsureshkumar@novell.com>
	    Ankit Jain	   <radical@corewars.org>

	* SqlGuid.cs: Fixed CompareTo to compare all the 16 digits. This
	is a LAMESPEC and current implementation matches ms.net. This
	actually reverts Uma's patch with revison 29013.

2005-02-03  Sureshkumar T  <tsureshkumar@novell.com>

	* SqlDateTime.cs : Parse : try with local culture first, then try
	with invariant culture if it fails.

2004-09-14 Umadevi S <sumadevi@novell.com>
        * Made SerializableAttribute !net_2_0 for all the exception classes

                                                                                                    
2004-09-14 Umadevi S <sumadevi@novell.com>
	* SqlAlreadyFilledException.cs, SqlNotFilledException.cs - Added these files

2004-07-21 Umadevi S <sumadevi@novell.com>
	* SqlInt16.cs, SqlInt32.cs, SqlInt64.cs - Added Modulus,CompareTo method from .NET2.0

2004-07-14 Umadevi S <sumadevi@novell.com>
	* SqlMoney.cs, SqlSingle.cs - Added CompareTo method from .NET2.0
	* Added new Enum StorageState.cs

2004-07-14 Umadevi S <sumadevi@novell.com>
	* SqlString.cs :Fixed + operator for null, CompareTo to throw SqlTypeException
			Implemented Add and CompareTo methods from .NET2.0

2004-06-18  Gert Driesen <drieseng@users.sourceforge.net>

	* SqlNullValueException.cs: fixed serialization
	* SqlTruncateException.cs: fixed serialization
	* SqlTypeException.cs: fixed serialization

2004-06-18  Sebastien Pouliot  <sebastien@ximian.com>

	* SqlMoney.cs: Removed old "hack" to correct scale after rounding as
	Decimal has been fixed (in fact this code was moved and adapted for
	Decimal as it was better than the previous fix).

2004-06-08 Umadevi S <sumadevi@novell.com>
	* SqlGuid.cs - fixed bug 59420. Implemented CompareTo according to MSDN documenation

2004-05-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDecimal.cs : don't output debug message to Console.

2004-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDecimal.cs : Fixed operator/ not to return positive always.
	  Halfly fixed ConvertToPrecScale() that was broken.

2004-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDecimal.cs :
	  - .ctor() should check the valid scale range and throw 
	    SqlTypeException.
	  - Value should copy the last int32 value fragment.
	  - Fixed Abs() and Ceiling() to return Null when the input is Null.
	  - Now AdjustScale() should not depend on Truncate() that keeps zero
	    digits correctly. So Round() before returning the final result.
	  - ToString() should insert '-' for minus values.
	  - operator+ should use larger scale of operands rather than smaller
	    scale.

2004-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDecimal.cs : Fixed Truncate() to work fine.
	* SqlMoney.cs : Added one hack line in operator/ to work fine.

2004-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDecimal.cs : Fixed AdjustScale(). When reducing digits, scale
	  parameter was incorrect.

2004-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlDecimal.cs :
	  - .ctor(double) initializes the precision as 17. If not sufficient,
	    it calls AdjustScale(), and if too much then it calls Round().
	  - Data should not return the internal array otherwise it might be
	    modified by outer code.
	  - Reimplemented AdjustScale() to work fine.
	  - Reimplemented Parse(). It should rather use Decimal.Parse() 
	    rather than SqlDouble.Parse() for parsable value range difference.
	  - Reimplemented Round(). Don't use double.
	  - Fixed ToString() to return "Null" for null value.
	  - Fixed explicit let operator to use double .ctor, not decimal
	    .ctor() so that precision can be handled in the same way as double.

2004-05-17  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlBinary.cs,
	  SqlDateTime.cs,
	  SqlDouble.cs,
	  SqlGuid.cs,
	  SqlMoney.cs,
	  SqlSingle.cs,
	  SqlString.cs : If values are null, ToString() should return "Null".

2004-05-11  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlMoney.cs : Handle fixed digits correctly.
	  Round decimal value before casting into other numeric types.
	* SqlInt16.cs,
	  SqlInt32.cs,
	  SqlInt64.cs : Round SqlMoney decimal value before casting into them.
	* SqlDateTime.cs :
	  Added range check.
	  Years and months were ignored in some .ctor().
	  Return invariant culture string in ToString().
	  Return null for operator - when operand is null.

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* SqlString.cs: change accessibility of CompareOptions property
	to private, commented out unreachable code

2004-04-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SqlBoolean.cs : Allow "0" and "1" on Parse(). Allow SqlString.Null
	  in conversion.
	* SqlString.cs : CompareOption should not be None.

2004-04-01  Lluis Sanchez Gual  <lluis@ximian.com>

	* SqlNullValueException.cs: Use a more clarifying error message.
	  
2003-12-19  Tim Coleman <tim@timcoleman.com>
	* SqlBytes.cs SqlChars.cs SqlDate.cs SqlStreamChars.cs SqlTime.cs
	* SqlUtcDateTime.cs SqlXmlReader.cs:
		New stubs added
2003-06-03  Ville Palo <vi64pa@kolumbus.fi>

	* SqlBinary.cs: Changed one SqlTypeException --> IndexOutOfRange
	* SqlMoney.cs: checkings
	
2003-06-02  Ville Palo <vi64pa@kolumbus.fi>

	* SqlString.cs: implementes less than and greater than operators.
	Added some checks to ctor.
		
2003-06-01  Ville Palo <vi64pa@kolumbus.fi>

	* SqlString.cs: added null checking
	
2003-05-28  Ville Palo <vi64pa@kolumbus.fi>

	* SqlMoney.cs: little fixes and clean ups
	
2003-05-28  Ville Palo <vi64pa@kolumbus.fi>

	* SqlInt16.cs: more checked fixes.
	* SqlInt64.cs: checked fixes.
	* SqlSingle.cs: checked fixes.
	
2003-05-28  Ville Palo <vi64pa@kolumbus.fi>

	* SqlInt16.cs: little fixes.
	
2003-05-28  Ville Palo <vi64pa@kolumbus.fi>

	* SqlDouble.cs: Some fixes. Mostly infinity checks
	* SqlSingle.cs: tiny fixes.
	* SqlInt64.cs: checked fix.
	
2003-05-28  Ville Palo <vi64pa@kolumbus.fi>

	* ChangeLog: Added this.
	* SqlByte.cs: Fixed checked parts
	

